#include <stdio.h>

#define SCR_WIDTH 160
#define FONT_WIDTH 6
#define MAX_CHARS (SCR_WIDTH/FONT_WIDTH)

void PrintUsage(void)
{
printf("
TextScroll Tool by Malcolm Smith
Takes an input text file, and formats
it into an array of strings for use
with the Oblivion text scroller.

Usage:
textScroll inputfile outputfile array_name
* inputfile and outputfile are normally Text (.TXT) files.
* array_name must be a standard C array name. It cannot
   begin with a number, and must be alphanumeric and the
   underscore (_). No spaces.
");
}

int main(int argc, char *argv[])
{
  FILE *f,*out;
  short a = 0, len, t;
  short count = 0;
  char *buffer;
  char marquee_cur[MAX_CHARS+1];
  unsigned short length=0;
  if(argc!=4) {PrintUsage();return 1;}
  f = fopen(argv[1],"rt");
  if(!f) {PrintUsage();return 1;}
  out = fopen(argv[2],"wt");
  if(!out) {PrintUsage();fclose(f);return 1;}
  while(!feof(f))
  {
   fgetc(f);
   length++;
  }
  rewind(f);
  buffer = (char*)malloc(length);

  fprintf(out,"const char* const %s[] = {\n",argv[3]);

  while (1)
  {
   if (fgets(buffer, length, f) == NULL) break;
   for(t=0;t<strlen(buffer);t++)
   {
    if(buffer[t] && buffer[t]<' ') buffer[t] = ' ';
   }
   while(1)
   {
   		//Get the length, up to MAX_CHARS
      len = strlen(buffer)>MAX_CHARS?MAX_CHARS:strlen(buffer);
      //Quit if length is 0
      if(!len) break;
      t=0;
      //Go forward until the end of a word, and while it's less than len
      while(buffer[t]!=' ' && t<len) t++;
      //if T equals MAX_CHARS, T is nonzero (otherwise zero)
      t= t==MAX_CHARS;
      //Go back until another space is encountered
      //(if the length is exactly right, leave alone)
      while(len && buffer[len-1]!=' ' && buffer[len] && !t) len--;
      //Terminate/ copy the string
      strncpy(marquee_cur,buffer,len);
      marquee_cur[len]=0;
      //Get rid of ending spaces
      if(len && marquee_cur[len-1]==' ') marquee_cur[len-1]=0;
      if(count) fprintf(out,",");
      fprintf(out,"\"%s\"",marquee_cur);
      count++;
      if(!(count&0x1)) fprintf(out,"\n");
      //Adjust the buffer (remove what was written)
      memmove(buffer,buffer+len,strlen(buffer)-len);
      buffer[strlen(buffer)-len]=0;
   }
  }
  fprintf(out,",NULL};\n");
  fclose(f);
  fclose(out);
  free(buffer);

  return 0;
}
